Models/CropModel.cs
using Microsoft.EntityFrameworkCore;
using System.Collections.Generic;

namespace CropWIKImvc.Models
{
    // Define the Crop entity class
    public class Crop
    {
        public int Id { get; set; } // Primary key
        public string User { get; set; }
        public string CropName { get; set; }
        public string CropType { get; set; }
        public string CropVariety { get; set; }
        public string PlantingPeriod { get; set; }
        public string HarvestingPeriod { get; set; }
        public string Description { get; set; }
        public string Image { get; set; }
        public string SoilType { get; set; }
        public string Climate { get; set; }
        public int ItShouldNotBeRepeatedForHowmanyYearsOnSameField { get; set; }
        public List<string> Fertilizers { get; set; }
        public List<string> Pests { get; set; }
        public List<string> Diseases { get; set; }
        public int NitrogenSupply { get; set; }
        public int NitrogenDemand { get; set; }
        public int SoilResidualNitrogen { get; set; }
    }


   

    // Define the database context class
    public class CropDbContext : DbContext
    {
        public CropDbContext(DbContextOptions<CropDbContext> options) : base(options)
        {
        }

        public DbSet<Crop> Crops { get; set; } // Represents the Crop table in the database
    }
}

Models/ErrorViewModel.cs
namespace CropWIKImvc.Models
{
    public class ErrorViewModel
    {
        public string? RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

Models/ModelServices/CropServices.cs
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using CropWIKImvc.Models;

namespace CropWIKImvc.Models.ModelServices
{
    public class CropServices
    {
        private readonly CropDbContext _context;

        public CropServices(CropDbContext context)
        {
            _context = context;
        }

        public List<Crop> GetAllCrops()
        {
            try
            {
                // Fetch crops from the database
                var crops = _context.Crops.ToList();

                // Return the fetched crops
                return crops;
            }
            catch (Exception ex)
            {
                // Log or handle the exception
                System.Diagnostics.Debug.WriteLine($"An error occurred while fetching crops: {ex.Message}");

                // Return some hardcoded values
                return new List<Crop>
        {
            new Crop
            {
                Id = 1,
                User = "JohnDoe",
                CropName = "Tomato",
                CropType = "Vegetable",
                CropVariety = "Roma",
                PlantingPeriod = "Spring",
                HarvestingPeriod = "Fall",
                Description = "Roma tomatoes are a plum tomato popularly used both for canning and producing tomato paste because of their slender and firm nature.",
                Image = "tomato_image.jpg",
                SoilType = "Loamy soil",
                Climate = "Temperate",
                ItShouldNotBeRepeatedForHowmanyYearsOnSameField = 3,
                Fertilizers = new List<string> { "Organic fertilizers" },
                Pests = new List<string> { "Aphids", "Whiteflies" },
                Diseases = new List<string> { "Bacterial spot", "Early blight" },
                NitrogenSupply = 50,
                NitrogenDemand = 40,
                SoilResidualNitrogen = 20
            },
            // Add more hardcoded crops 
            new Crop
            {
                Id = 2,
                User = "JaneDoe",
                CropName = "Potato",
                CropType = "Vegetable",
                CropVariety = "Russet",
                PlantingPeriod = "Spring",
                HarvestingPeriod = "Fall",
                Description = "Russet potatoes are large, starchy potatoes with a brown skin and white flesh. They are commonly used for baking, mashing, and frying.",
                Image = "potato_image.jpg",
                SoilType = "Sandy soil",
                Climate = "Cool",
                ItShouldNotBeRepeatedForHowmanyYearsOnSameField = 2,
                Fertilizers = new List<string> { "Potassium fertilizers" },
                Pests = new List<string> { "Colorado potato beetle", "Aphids" },
                Diseases = new List<string> { "Late blight", "Early blight" },
                NitrogenSupply = 40,
                NitrogenDemand = 30,
                SoilResidualNitrogen = 15
            }
            };
            }
        }
    }
}

Controllers/Crops/CropController.cs
using CropWIKImvc.Models;
using CropWIKImvc.Models.ModelServices;
using Microsoft.AspNetCore.Mvc;

namespace CropWIKImvc.Controllers.Crop
{
    public class CropController : Controller
    {
        private readonly CropServices _cropService;

        public CropController(CropServices cropService)
        {
            _cropService = cropService;
        }

        // GET: CropController
        public ActionResult Index()
        {
            System.Diagnostics.Debug.WriteLine("test ");
            // Retrieve all crops using CropService
            List<Models.Crop> crops = _cropService.GetAllCrops();

            // Pass the list of crops to the view
            return View("Views/Home/Index.cshtml", crops);
        }

        // GET: CropController/Details/5
        public ActionResult Details(int id)
        {
            return View();
        }

        // GET: CropController/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: CropController/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(IFormCollection collection)
        {
            try
            {
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: CropController/Edit/5
        public ActionResult Edit(int id)
        {
            return View();
        }

        // POST: CropController/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit(int id, IFormCollection collection)
        {
            try
            {
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: CropController/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }

        // POST: CropController/Delete/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Delete(int id, IFormCollection collection)
        {
            try
            {
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }
    }
}

Controllers/HomeController.cs
using CropWIKImvc.Models;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using System.Diagnostics;
using Microsoft.Graph;
using Microsoft.Identity.Web;

namespace CropWIKImvc.Controllers
{
    [Authorize]
    public class HomeController : Controller
    {
        private readonly GraphServiceClient _graphServiceClient;
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger, GraphServiceClient graphServiceClient)
        {
            _logger = logger;
            _graphServiceClient = graphServiceClient;;
        }

        [AuthorizeForScopes(ScopeKeySection = "MicrosoftGraph:Scopes")]
        public async Task<IActionResult> Index()
        {
var user = await _graphServiceClient.Me.Request().GetAsync();
ViewData["GraphApiResult"] = user.DisplayName;
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }


        [AllowAnonymous]
        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }

    }

}

Views/Home/Index.cshtml
@model List<CropWIKImvc.Models.Crop>

@{
    // This is an async lambda expression
    Func<Task> displayCropsAsync = async () =>
    {
        foreach (var crop in Model)
        {
            await DisplayCropDataAsync(crop);
        }
    };

    // Call the async lambda expression
    displayCropsAsync();
}

@functions {
    async Task DisplayCropDataAsync(CropWIKImvc.Models.Crop crop)
    
    {
        var cropData = new Dictionary<string, object>
        {
            { "User", crop.User },
            { "CropName", crop.CropName },
            { "CropType", crop.CropType },
            { "CropVariety", crop.CropVariety },
            { "PlantingPeriod", crop.PlantingPeriod },
            { "HarvestingPeriod", crop.HarvestingPeriod },
            { "Description", crop.Description },
            { "Image", crop.Image },
            { "SoilType", crop.SoilType },
            { "Climate", crop.Climate },
            { "ItShouldNotBeRepeatedForHowmanyYearsOnSameField", crop.ItShouldNotBeRepeatedForHowmanyYearsOnSameField },
            { "Fertilizers", crop.Fertilizers },
            { "Pests", crop.Pests },
            { "Diseases", crop.Diseases },
            { "NitrogenSupply", crop.NitrogenSupply },
            { "NitrogenDemand", crop.NitrogenDemand },
            { "SoilResidualNitrogen", crop.SoilResidualNitrogen }
        };

        <p>This is server rendered:</p>

        <div id="cropData">
            <h2>@(cropData["CropName"])</h2>
            <p>Type: @(cropData["CropType"])</p>
            <!-- Add more properties as needed -->
        </div>

        <p>This is web assembly</p>

        <component type="typeof(CropWIKIWebAssembly.Pages.Counter)" render-mode="WebAssemblyPrerendered" param-CropData="@cropData"></component>
    }
}

@section Scripts {
    <script src="_framework/blazor.webassembly.js"></script>
}

Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - CropWIKImvc</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/CropWIKImvc.styles.css" asp-append-version="true" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container-fluid">
                <a class="navbar-brand" asp-area="" asp-controller="Crop" asp-action="Index">CropWIKImvc</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Crop" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>
                    </ul>
                    <partial name="_LoginPartial" />
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2024 - CropWIKImvc - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>